import { Config, ConfigWithDefaults } from './config';
export interface SpawnResult {
    pid: number;
    stdout: string;
    stderr: string;
    error?: Error;
    status: number | null;
}
export interface StartError extends Error {
    startResult: StartResult;
}
export interface StartResult {
    receivedConfig: Config;
    enrichedConfig?: ConfigWithDefaults;
    spawnResult?: SpawnResult;
}
export declare function start(configWithoutDefaults: Config): Promise<StartResult>;
export declare function createFilesAndDirectories(config: ConfigWithDefaults): Promise<void>;
export declare function stop(): Promise<void>;
