"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.stop = exports.createFilesAndDirectories = exports.start = void 0;
var child_process_1 = require("child_process");
var fs_1 = require("fs");
var path_1 = __importDefault(require("path"));
var configDefaults_1 = require("./configDefaults");
var configGenerator_1 = require("./configGenerator");
var configValidation_1 = require("./configValidation");
var ssl_1 = require("./ssl");
function start(configWithoutDefaults) {
    return __awaiter(this, void 0, void 0, function () {
        var config, startResult, e_1, spawnResult;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    config = (0, configDefaults_1.setDefaults)(configWithoutDefaults);
                    startResult = {
                        receivedConfig: configWithoutDefaults,
                        enrichedConfig: config
                    };
                    try {
                        (0, configValidation_1.validate)(config);
                    }
                    catch (e) {
                        e.startResult = startResult;
                        throw e;
                    }
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, createFilesAndDirectories(config)];
                case 2:
                    _a.sent();
                    return [3 /*break*/, 4];
                case 3:
                    e_1 = _a.sent();
                    e_1.startResult = startResult;
                    throw e_1;
                case 4:
                    try {
                        spawnResult = startNginx(config);
                        startResult.spawnResult = spawnResult;
                    }
                    catch (e) {
                        startResult.spawnResult = e.spawnResult;
                        e.startResult = startResult;
                        throw e;
                    }
                    return [2 /*return*/, startResult];
            }
        });
    });
}
exports.start = start;
// exported for testing purposes
function createFilesAndDirectories(config) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: 
                // Remove all information related to the previous run.
                return [4 /*yield*/, cleanTmpDir(config)];
                case 1:
                    // Remove all information related to the previous run.
                    _a.sent();
                    // And completely re-create the structure.
                    return [4 /*yield*/, fs_1.promises.mkdir(config.tmpDir, { mode: '755', recursive: true })];
                case 2:
                    // And completely re-create the structure.
                    _a.sent();
                    return [4 /*yield*/, Promise.all([
                            writeNginxConfig(config),
                            fs_1.promises.mkdir(path_1.default.join(config.tmpDir, 'clientBody'), { mode: '755' }),
                            fs_1.promises.mkdir(path_1.default.join(config.tmpDir, 'proxy'), { mode: '755' }),
                            fs_1.promises.mkdir(path_1.default.resolve(config.tmpDir, config.logDir), {
                                mode: '755',
                                recursive: true,
                            }),
                            fs_1.promises.copyFile(path_1.default.join(__dirname, '..', 'templates', 'mime.types'), path_1.default.join(config.tmpDir, 'mime.types')),
                            copyCertificates(config),
                        ])];
                case 3:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
exports.createFilesAndDirectories = createFilesAndDirectories;
function cleanTmpDir(config) {
    return __awaiter(this, void 0, void 0, function () {
        var e_2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 3, , 4]);
                    return [4 /*yield*/, fs_1.promises.stat(config.tmpDir)];
                case 1:
                    _a.sent();
                    // We could use the 'force' flag here, but just to avoid a potentially
                    // harmful rm -rf code path, we just don't
                    return [4 /*yield*/, fs_1.promises.rm(config.tmpDir, { recursive: true })];
                case 2:
                    // We could use the 'force' flag here, but just to avoid a potentially
                    // harmful rm -rf code path, we just don't
                    _a.sent();
                    return [3 /*break*/, 4];
                case 3:
                    e_2 = _a.sent();
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/];
            }
        });
    });
}
function writeNginxConfig(config) {
    return __awaiter(this, void 0, void 0, function () {
        var configStr;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, (0, configGenerator_1.generate)(config)];
                case 1:
                    configStr = _a.sent();
                    return [4 /*yield*/, fs_1.promises.writeFile(path_1.default.join(config.tmpDir, 'nginx.conf'), configStr)];
                case 2:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
function copyCertificates(config) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!config.tls) {
                        return [2 /*return*/];
                    }
                    if (!(config.tlsCertificateFile && config.tlsCertificateKeyFile)) return [3 /*break*/, 2];
                    return [4 /*yield*/, Promise.all([
                            fs_1.promises.copyFile(config.tlsCertificateFile, path_1.default.join(config.tmpDir, 'server.crt')),
                            fs_1.promises.copyFile(config.tlsCertificateKeyFile, path_1.default.join(config.tmpDir, 'server.key')),
                        ])];
                case 1:
                    _a.sent();
                    return [3 /*break*/, 4];
                case 2: return [4 /*yield*/, (0, ssl_1.createCertificates)(config.tmpDir)];
                case 3:
                    _a.sent();
                    _a.label = 4;
                case 4: return [2 /*return*/];
            }
        });
    });
}
function startNginx(config) {
    var spawnResult = (0, child_process_1.spawnSync)('nginx', ['-c', path_1.default.join(config.tmpDir, 'nginx.conf'), '-p', config.tmpDir], {
        stdio: 'inherit',
        encoding: 'utf8',
    });
    var error;
    if (spawnResult.error) {
        error = new Error('Failed to start the server: ' + spawnResult.error, 
        // @ts-expect-error Error causes are not yet supported by TypeScript
        {
            cause: spawnResult.error,
        });
    }
    else if (spawnResult.status !== 0) {
        error = new Error('Failed to start the server. Server exited with a status code != 0');
    }
    if (error) {
        error.spawnResult = spawnResult;
        throw error;
    }
    return spawnResult;
}
function stop() {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            (0, child_process_1.spawnSync)('pkill', ['-f', 'nginx: master process'], { encoding: 'utf8' });
            return [2 /*return*/];
        });
    });
}
exports.stop = stop;
